using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Drawing.Printing;

namespace Test2
{
    public partial class Form1 : Form
    {
        private bool _isPrintOnSamePage = false;
        public Form1()
        {
            InitializeComponent();

        }

        private void Form1_Load(object sender, System.EventArgs e)
        {
            // Create a data table with 3 columns.
            DataTable dt = new DataTable("Table1");
            dt.Columns.Add("Col0", typeof(string));
            dt.Columns.Add("Col1", typeof(string));
            dt.Columns.Add("Col2", typeof(string));
            dt.Columns.Add("Col3", typeof(string));
            dt.Columns.Add("Col4", typeof(string));
            dt.Columns.Add("Col5", typeof(string));
            dt.Columns.Add("Col6", typeof(string));
            dt.Columns.Add("Col7", typeof(string));

            // Fill the data table with some random data.
            for (int i = 0; i < 2; i++)
                dt.Rows.Add(new string[] { "Test" + i + 1, "Test" + i + 2, "Test" + i + 3, "Test" + i + 4, "Test" + i + 5, "Test" + i + 6, "Test" + i + 7, "Test" + i + 8});

            // Set the grid's data source to the data table.
            this.ultraGrid1.DataSource = dt;
        }
        
        private void ultraGrid1_InitializePrint(object sender, CancelablePrintEventArgs e)
        {
            //In this case , arrange the columns 
            if (!_isPrintOnSamePage)
            {
                UltraGridBand band = this.ultraGrid1.DisplayLayout.Bands["Table1"];
                band = e.PrintLayout.Bands[0];
                band.Override.RowSpacingAfter = 5;
                // Turn on the row layout functionality for Table1 band.
                band.UseRowLayout = true;

                /***********************************************************/
               // band.RowLayoutLabelStyle = RowLayoutLabelStyle.WithCellData;
                /***********************************************************/
                for (int i = 5; i < 8; i++)
                {
                    UltraGridColumn columnInTopRow = band.Columns["Col" + (i - 5).ToString()];
                    UltraGridColumn columnUnderneath = band.Columns["Col" + i.ToString()];

                    columnUnderneath.RowLayoutColumnInfo.OriginX = columnInTopRow.RowLayoutColumnInfo.OriginXResolved;
                    columnUnderneath.RowLayoutColumnInfo.SpanX = columnInTopRow.RowLayoutColumnInfo.SpanXResolved;
                    columnUnderneath.RowLayoutColumnInfo.SpanY = columnInTopRow.RowLayoutColumnInfo.OriginYResolved + columnInTopRow.RowLayoutColumnInfo.SpanYResolved;
                }
            }
            _isPrintOnSamePage = false;
        }

     

        private void NormalPrintButton_Click(object sender, EventArgs e)
        {
            _isPrintOnSamePage = true;
            CallPrintPreivew();
        }

        private void ultraButtonCustomizedPreview_Click(object sender, EventArgs e)
        {
            CallPrintPreivew();
        }


        private void CallPrintPreivew()
        {
            this.ultraGridPrintDocument1.Grid = this.ultraGrid1;
            this.ultraPrintPreviewDialog1.Document = this.ultraGridPrintDocument1;
            ultraPrintPreviewDialog1.ShowDialog(this);
        }

       
    }
}